(* PBM Reader - reads PBM files and displays them on the screen. *)
(* Version 2.0 *)
program PbmReader;
(*$IKERNEL.INC*)
(*$IGRAPHLIB.INC*)
(*$IINPUT.INC*)
(*$IBOX.INC*)
(*$ISCREEN.INC*)
(*$IPBMIN.INC*)

label
  byebye;
var
  FileName: string(.14.);
  err:      ErrorCode;

(* Main program *)
begin
  ClrScr;
  
  (* get the name of the PBM file *)
  if ParamCount > 0 then begin
    FileName := ParamStr(1); (* first commandline parameter treated as filename *)
  end
  else begin
    DrawBox(1, 1, 90, 3);
    GotoXY(28, 2);
    Write('PBM file reader V2.0 by Bernd Bock');
    DrawBox(1, 4, 90, 3);
    GotoXY(3, 5);
    Write('Enter name of PBM file: ');
    FileName := InputFileName;
    GotoXY(1, 7);
    if Length(FileName) = 0 then goto byebye; (* abort if no filename entered *)
  end;
  
  GraphInit;
  HideCursor;

  err := LoadScreenFromPBM(FileName);
  if err <> ErrOk then begin
    case err of
      ErrFileNotFound:       WriteLn('File not found!');
      ErrFormatNotSupported: WriteLn('Format not supported: only 720x256 or 720x512 binary - PBM type 4')
      else                   WriteLn('Unknown error!');
    end;
    WriteKeyMessage;
  end;
  
  WaitForKey;
  
byebye:  
  ShowCursor;
end.
